//
//  ViewController.m
//  menuView
//
//  Created by CLARKYJ on 17/1/19.
//  Copyright © 2017年 CLARKYJ. All rights reserved.
//

#import "ViewController.h"


@interface ViewController ()

@property(nonatomic,retain) NSMutableArray* dataSource;

@end

@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    [self generateDataSource];
    
    CGRect screenRect = [[UIScreen mainScreen] bounds];
    UIButton* LeftTop = [[UIButton alloc] initWithFrame:CGRectMake(20, 100, screenRect.size.width - 40, 50)];
    [LeftTop.layer setCornerRadius:5];
    [LeftTop setTitle:@"左上角弹出" forState:UIControlStateNormal];
    [LeftTop setBackgroundColor:[UIColor lightGrayColor]];
    [LeftTop addTarget:self action:@selector(btnClicked:) forControlEvents:UIControlEventTouchUpInside];
    LeftTop.tag = 1;
    [self.view addSubview:LeftTop];
    
    UIButton* RightTop = [[UIButton alloc] initWithFrame:CGRectMake(20, 175, screenRect.size.width - 40, 50)];
    [RightTop.layer setCornerRadius:5];
    [RightTop setTitle:@"右上角弹出" forState:UIControlStateNormal];
    [RightTop setBackgroundColor:[UIColor lightGrayColor]];
    [RightTop addTarget:self action:@selector(btnClicked:) forControlEvents:UIControlEventTouchUpInside];
    RightTop.tag = 2;
    [self.view addSubview:RightTop];
    
    UIButton* Bottom = [[UIButton alloc] initWithFrame:CGRectMake(20, 250, screenRect.size.width - 40, 50)];
    [Bottom.layer setCornerRadius:5];
    [Bottom setTitle:@"底部弹出" forState:UIControlStateNormal];
    [Bottom setBackgroundColor:[UIColor lightGrayColor]];
    [Bottom addTarget:self action:@selector(btnClicked:) forControlEvents:UIControlEventTouchUpInside];
    Bottom.tag = 3;
    [self.view addSubview:Bottom];
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


- (void)generateDataSource
{
    _dataSource = [NSMutableArray array];
    for (int index = 0; index < 5; index++)
    {
        menuViewModel* mdl = [[menuViewModel alloc] init];
        mdl.iconName = @"menuicon.png";
        mdl.title = [NSString stringWithFormat:@"NumberID:%d",index];
        mdl.cellID = index;
        if (index == 5) {
            mdl.fontColor = [UIColor blackColor];
        }
        [_dataSource addObject:mdl];
    }
}

- (void)btnClicked:(id)sender
{
    if ([sender isKindOfClass:[UIButton class]])
    {
        menuRegInfo* regInfo = [[menuRegInfo alloc] init];
        switch (((UIButton*)sender).tag) {
            case 1:
            {
                //左上角弹出
                regInfo.viewMainAxis = menuView_down;
                regInfo.viewViceAxis = menuView_Right;
                regInfo.animationDirection = menuAnimation_RightBttom;
                regInfo.bgColor = [UIColor lightGrayColor];
                regInfo.viewDistance = menuTriangle_Near;
                regInfo.viewBeginPoint = CGPointMake(0, 320);
            }
                break;
            case 2:
            {
                //右上角弹出
                regInfo.viewMainAxis = menuView_down;
                regInfo.viewViceAxis = menuView_Left;
                regInfo.animationDirection = menuAnimation_LeftBottom;
                regInfo.bgColor = [UIColor lightGrayColor];
                regInfo.viewDistance = menuTriangle_Near;
                regInfo.viewBeginPoint = CGPointMake(self.view.bounds.size.width,
                                                     320);
            }
                break;
            case 3:
            {
                //底部弹出
                regInfo.viewMainAxis = menuView_Right;
                regInfo.viewViceAxis = menuView_up;
                regInfo.animationDirection = menuAnimation_Top;
                regInfo.bgColor = [UIColor lightGrayColor];
                regInfo.viewDistance = menuTriangle_Middle;
                regInfo.viewBeginPoint = CGPointMake(self.view.bounds.size.width / 2 - 80, self.view.bounds.size.height);
                regInfo.width = 160;
            }
                break;
            default:
                break;
        }
        
        menuView* menuview = [[menuView alloc] initWithFrame:self.view.bounds regInfo:regInfo];
        menuview.dataSource = self.dataSource;
        menuview.delegate = self;
        [menuview slideOut];
    }
}

- (void)menuCellDidClick:(NSNumber *)cellID
{
    UIAlertController *alertController = [UIAlertController alertControllerWithTitle:@"点击结果"
                                                                             message:[NSString stringWithFormat:@"点击了cell:%d", [cellID intValue]]
                                                                      preferredStyle:UIAlertControllerStyleAlert];
    UIAlertAction *okAction = [UIAlertAction actionWithTitle:@"好的" style:UIAlertActionStyleDefault handler:nil];
    [alertController addAction:okAction];
    [self presentViewController:alertController animated:YES completion:nil];
}

@end
